searchData={"items":[{"type":"behaviour","title":"Mixpanel","doc":"Elixir client for the Mixpanel API.","ref":"Mixpanel.html"},{"type":"callback","title":"Mixpanel.create_alias/2","doc":"Creates an alias for a distinct ID, merging two profiles. Mixpanel supports\nadding an alias to a distinct id. An alias is a new value that will be\ninterpreted by Mixpanel as an existing value. That means that you can send\nmessages to Mixpanel using the new value, and Mixpanel will continue to use\nthe old value for calculating funnels and retention reports, or applying\nupdates to user profiles.","ref":"Mixpanel.html#c:create_alias/2"},{"type":"callback","title":"Arguments - Mixpanel.create_alias/2","doc":"* `alias_id` - The new additional ID of the user.\n* `distinct_id` - The current ID of the user.","ref":"Mixpanel.html#c:create_alias/2-arguments"},{"type":"callback","title":"Mixpanel.engage/2","doc":"Same as `f:engage/4`, but accepts a list of `{distinct_id, operation, value}`\ntuples, then forms a batch request and send it the Ingestion API.","ref":"Mixpanel.html#c:engage/2"},{"type":"callback","title":"Arguments - Mixpanel.engage/2","doc":"* `batch` - See `f:engage/4` for details.\n* `opts` - See `t:engage_options/0` for specific options to pass to this\n  function.","ref":"Mixpanel.html#c:engage/2-arguments"},{"type":"callback","title":"Mixpanel.engage/4","doc":"Takes a `value` map argument containing names and values of profile\nproperties. If the profile does not exist, it creates it with these\nproperties. If it does exist, it sets the properties to these values,\noverwriting existing values.","ref":"Mixpanel.html#c:engage/4"},{"type":"callback","title":"Arguments - Mixpanel.engage/4","doc":"* `distinct_id` - This is a string that identifies the profile you would like\n  to update.\n* `operation` - A name for the event.\n* `value`- A collection of properties associated with this event.\n* `opts` - See `t:engage_options/0` for specific options to pass to this\n  function.","ref":"Mixpanel.html#c:engage/4-arguments"},{"type":"function","title":"Mixpanel.start_client/1","doc":"Dynamically starts a new client process.","ref":"Mixpanel.html#start_client/1"},{"type":"function","title":"Examples - Mixpanel.start_client/1","doc":"iex> Mixpanel.start_client(Mixpanel.Config.client(MyApp.Mixpanel.US, [project_token: \"token\"]))\n    {:ok, #PID }\n    iex> Mixpanel.start_client(Mixpanel.Config.client(MyApp.Mixpanel.US, [project_token: \"token\"]))\n    {:error, {:already_started, #PID }}","ref":"Mixpanel.html#start_client/1-examples"},{"type":"function","title":"Mixpanel.terminate_client/1","doc":"Stops a client process.","ref":"Mixpanel.html#terminate_client/1"},{"type":"function","title":"Examples - Mixpanel.terminate_client/1","doc":"iex> Mixpanel.terminate_client(MyApp.Mixpanel.US)\n    :ok\n    iex> Mixpanel.terminate_client(MyApp.Mixpanel.US)\n    {:error, :not_found}\n    iex> Process.whereis(MyApp.Mixpanel.EU)\n    nil","ref":"Mixpanel.html#terminate_client/1-examples"},{"type":"callback","title":"Mixpanel.track/3","doc":"Tracks an event.","ref":"Mixpanel.html#c:track/3"},{"type":"callback","title":"Arguments - Mixpanel.track/3","doc":"* `event` - A name for the event.\n* `properties` - A collection of properties associated with this event.\n* `opts` - See `t:track_options/0` for specific options to pass to this\n  function.","ref":"Mixpanel.html#c:track/3-arguments"},{"type":"type","title":"Mixpanel.common_options/0","doc":"Possible common options to be passed to `Mixpanel.track/3` and `Mixpanel.engage/3`.\n\n* `:time` - The time an event occurred. If this property is not included in\n  your request, Mixpanel will use the time the event arrives at the server.\n  If present, the value should be one of:\n  * `NaiveDateTime` struct (Etc/UTC timezone is assumed)\n  * `DateTime` struct\n  * a Unix timestamp (seconds since midnight, January 1st, 1970 - UTC)\n  * an Erlang's `:erlang.timestamp()` tuple (`{mega_secs, secs, ms}`,\n    microseconds are not supported)\n  * an Erlang's `:calendar.datetime()` tuple (`{{yyyy, mm, dd}, {hh, mm, ss}}`)\n* `:ip` - An IP address string (e.g. \"127.0.0.1\") associated with the event.\n  This is used for adding geolocation data to events, and should only be\n  required if you are making requests from your backend. If `:ip` is absent,\n  Mixpanel will ignore the IP address of the request.","ref":"Mixpanel.html#t:common_options/0"},{"type":"type","title":"Mixpanel.engage_options/0","doc":"Possible options to be passed to `Mixpanel.engage/3`.\n\n* `:ignore_time` - If the `:ignore_time` property is present and `true` in\n  your update request, Mixpanel will not automatically update the \"Last Seen\"\n  property of the profile. Otherwise, Mixpanel will add a \"Last Seen\" property\n  associated with the current time for all $set, $append, and $add operations.","ref":"Mixpanel.html#t:engage_options/0"},{"type":"type","title":"Mixpanel.track_options/0","doc":"Possible options to be passed to `Mixpanel.track/3`.\n\n* `:distinct_id` - The value of distinct_id will be treated as a string, and\n  used to uniquely identify a user associated with your event. If you provide\n  a distinct_id with your events, you can track a given user through funnels\n  and distinguish unique users for retention analyses. You should always send\n  the same distinct_id when an event is triggered by the same user.","ref":"Mixpanel.html#t:track_options/0"},{"type":"module","title":"Mixpanel.Client","doc":"Mixpanel API Client GenServer.","ref":"Mixpanel.Client.html"},{"type":"function","title":"Mixpanel.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mixpanel.Client.html#child_spec/1"},{"type":"function","title":"Mixpanel.Client.create_alias/3","doc":"Creates an alias for a user profile.\n\nSee `Mixpanel.create_alias/2`.","ref":"Mixpanel.Client.html#create_alias/3"},{"type":"function","title":"Mixpanel.Client.engage/3","doc":"Updates a user profile.\n\nSee `Mixpanel.engage/4`.","ref":"Mixpanel.Client.html#engage/3"},{"type":"function","title":"Mixpanel.Client.engage/5","doc":"","ref":"Mixpanel.Client.html#engage/5"},{"type":"function","title":"Mixpanel.Client.start_link/1","doc":"","ref":"Mixpanel.Client.html#start_link/1"},{"type":"function","title":"Mixpanel.Client.track/4","doc":"Tracks a event\n\nSee `Mixpanel.track/3`","ref":"Mixpanel.Client.html#track/4"},{"type":"type","title":"Mixpanel.Client.alias_id/0","doc":"","ref":"Mixpanel.Client.html#t:alias_id/0"},{"type":"type","title":"Mixpanel.Client.distinct_id/0","doc":"","ref":"Mixpanel.Client.html#t:distinct_id/0"},{"type":"type","title":"Mixpanel.Client.event/0","doc":"","ref":"Mixpanel.Client.html#t:event/0"},{"type":"type","title":"Mixpanel.Client.init_args/0","doc":"","ref":"Mixpanel.Client.html#t:init_args/0"},{"type":"type","title":"Mixpanel.Client.properties/0","doc":"","ref":"Mixpanel.Client.html#t:properties/0"},{"type":"module","title":"Mixpanel.Config","doc":"Module that helps handling configuration values provided by a user.","ref":"Mixpanel.Config.html"},{"type":"function","title":"Mixpanel.Config.client/2","doc":"Helper that validates user provided configuration and substitutes default\nparameters when needed.","ref":"Mixpanel.Config.html#client/2"},{"type":"function","title":"Examples - Mixpanel.Config.client/2","doc":"iex> Mixpanel.Config.client(MyApp.Mixpanel, [project_token: \"token\"])\n    [\n      http_adapter: Mixpanel.HTTP.HTTPC,\n      base_url: \"https://api.mixpanel.com\",\n      name: MyApp.Mixpanel,\n      project_token: \"token\"\n    ]","ref":"Mixpanel.Config.html#client/2-examples"},{"type":"type","title":"Mixpanel.Config.base_url/0","doc":"","ref":"Mixpanel.Config.html#t:base_url/0"},{"type":"type","title":"Mixpanel.Config.http_adapter/0","doc":"","ref":"Mixpanel.Config.html#t:http_adapter/0"},{"type":"type","title":"Mixpanel.Config.name/0","doc":"","ref":"Mixpanel.Config.html#t:name/0"},{"type":"type","title":"Mixpanel.Config.option/0","doc":"","ref":"Mixpanel.Config.html#t:option/0"},{"type":"type","title":"Mixpanel.Config.options/0","doc":"","ref":"Mixpanel.Config.html#t:options/0"},{"type":"type","title":"Mixpanel.Config.project_token/0","doc":"","ref":"Mixpanel.Config.html#t:project_token/0"},{"type":"behaviour","title":"Mixpanel.HTTP","doc":"Adapter specification for HTTP clients and API for accessing them.","ref":"Mixpanel.HTTP.html"},{"type":"callback","title":"Mixpanel.HTTP.get/3","doc":"","ref":"Mixpanel.HTTP.html#c:get/3"},{"type":"function","title":"Mixpanel.HTTP.get/4","doc":"","ref":"Mixpanel.HTTP.html#get/4"},{"type":"callback","title":"Mixpanel.HTTP.post/4","doc":"","ref":"Mixpanel.HTTP.html#c:post/4"},{"type":"function","title":"Mixpanel.HTTP.post/5","doc":"","ref":"Mixpanel.HTTP.html#post/5"},{"type":"module","title":"Mixpanel.HTTP.HTTPC","doc":"Adapter for [httpc](http://erlang.org/doc/man/httpc.html).\n\nThis is the default adapter.","ref":"Mixpanel.HTTP.HTTPC.html"},{"type":"module","title":"Mixpanel.HTTP.Hackney","doc":"Adapter for [hackney](https://github.com/benoitc/hackney).\n\nRemember to add `{:hackney, \"~> 1.20\"}` to dependencies (and `:hackney` to applications in `mix.exs`).","ref":"Mixpanel.HTTP.Hackney.html"},{"type":"module","title":"Examples - Mixpanel.HTTP.Hackney","doc":"```\n# set globally in config/config.exs\nconfig :mixpanel_api_ex, :http_adapter, Mixpanel.HTTP.Hackney\n```","ref":"Mixpanel.HTTP.Hackney.html#module-examples"},{"type":"module","title":"Adapter specific options - Mixpanel.HTTP.Hackney","doc":"- `:max_body_length` - Max response body size in bytes. Actual response may\n  be bigger because hackney stops after the last chunk that surpasses\n  `:max_body_length`. Defaults to `:infinity`.","ref":"Mixpanel.HTTP.Hackney.html#module-adapter-specific-options"},{"type":"module","title":"Mixpanel.HTTP.NoOp","doc":"A fake adapter which primary should be used for testing purposes.","ref":"Mixpanel.HTTP.NoOp.html"},{"type":"behaviour","title":"Mixpanel.Queue","doc":"","ref":"Mixpanel.Queue.html"},{"type":"callback","title":"Mixpanel.Queue.length/1","doc":"","ref":"Mixpanel.Queue.html#c:length/1"},{"type":"callback","title":"Mixpanel.Queue.new/1","doc":"","ref":"Mixpanel.Queue.html#c:new/1"},{"type":"callback","title":"Mixpanel.Queue.push/2","doc":"","ref":"Mixpanel.Queue.html#c:push/2"},{"type":"callback","title":"Mixpanel.Queue.take/2","doc":"","ref":"Mixpanel.Queue.html#c:take/2"},{"type":"module","title":"Mixpanel.Telemetry","doc":"The following telemetry spans are emitted by mixpanel_api_ex:\n\n## `[:mixpanel_api_ex, :client, *]`\n\nRepresents a Mixpanel API client is ready\n\nThis span is started by the following event:\n\n* `[:mixpanel_api_ex, :client, :start]`\n\n    Represents the start of the span\n\n    This event contains the following measurements:\n\n    * `monotonic_time`: The time of this event, in `:native` units\n\n    This event contains the following metadata:\n\n    * `name`: The name of the client\n    * `base_url`: The URL which a client instance uses to communicate with\n      the Mixpanel API\n    * `http_adapter`: The HTTP adapter which a client instance uses to send\n      actual requests to the backend\n\nThis span is ended by the following event:\n\n* `[:mixpanel_api_ex, :client, :stop]`\n\n    Represents the end of the span\n\n    This event contains the following measurements:\n\n    * `monotonic_time`: The time of this event, in `:native` units\n    * `duration`: The span duration, in `:native` units\n\n    This event contains the following metadata:\n\n    * `name`: The name of the client\n    * `base_url`: The URL which a client instance uses to communicate with\n      the Mixpanel API\n    * `http_adapter`: The HTTP adapter which a client instance uses to send\n      actual requests to the backend\n\nThe following events may be emitted within this span:\n\n* `[:mixpanel_api_ex, :client, :send]`\n\n    Represents a request sent to the Mixpanel API\n\n    This event contains the following measurements:\n\n    * `event`: The name of the event that was sent\n    * `payload_size`: The size (in bytes) of the payload has been sent\n\n    This event contains the following metadata:\n\n    * `telemetry_span_context`: A unique identifier for this span\n    * `name`: The name of the client\n\n* `[:mixpanel_api_ex, :client, :send_error]`\n\n    An error occurred while sending a request to the Mixpanel API\n\n    This event contains the following measurements:\n\n    * `event`: The name of the event that was attempted to send\n    * `error`: A description of the error\n    * `payload_size`: The size (in bytes) of the payload that were attempted to send\n\n    This event contains the following metadata:\n\n    * `telemetry_span_context`: A unique identifier for this span\n    * `name`: The name of the client","ref":"Mixpanel.Telemetry.html"},{"type":"type","title":"Mixpanel.Telemetry.metadata/0","doc":"","ref":"Mixpanel.Telemetry.html#t:metadata/0"},{"type":"type","title":"Mixpanel.Telemetry.span_name/0","doc":"","ref":"Mixpanel.Telemetry.html#t:span_name/0"},{"type":"type","title":"Mixpanel.Telemetry.t/0","doc":"","ref":"Mixpanel.Telemetry.html#t:t/0"},{"type":"extras","title":"Mixpanel","doc":"# Mixpanel\n\n[![Module Version](https://img.shields.io/hexpm/v/mixpanel_api_ex.svg)](https://hex.pm/packages/mixpanel_api_ex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/mixpanel_api_ex/)\n[![Total Downloads](https://img.shields.io/hexpm/dt/mixpanel_api_ex.svg)](https://hex.pm/packages/mixpanel_api_ex)\n[![License](https://img.shields.io/hexpm/l/mixpanel_api_ex.svg)](https://github.com/asakura/mixpanel_api_ex/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/asakura/mixpanel_api_ex.svg)](https://github.com/asakura/mixpanel_api_ex/commits/master)\n[![Coverage Status](https://coveralls.io/repos/github/asakura/mixpanel_api_ex/badge.svg?branch=master)](https://coveralls.io/github/asakura/mixpanel_api_ex?branch=master)\n[![CI](https://github.com/asakura/mixpanel_api_ex/actions/workflows/elixir.yml/badge.svg)](https://github.com/asakura/mixpanel_api_ex/actions)\n\nThis is a non-official third-party Elixir client for the\n[Mixpanel](https://mixpanel.com/).\n\n> Note that this README refers to the `master` branch of `mixpanel_api_ex`, not\n  the latest released version on Hex. See\n  [the documentation](https://hexdocs.pm/mixpanel_api_ex) for the documentation\n  of the version you're using.\n\nFor the list of changes, checkout the latest\n[release notes](https://github.com/asakura/mixpanel_api_ex/CHANGESET.md).","ref":"readme.html"},{"type":"extras","title":"Installation - Mixpanel","doc":"Add `mixpanel_api_ex` to your list of dependencies in `mix.exs`.\n\n```elixir\ndef deps do\n  [\n    {:mixpanel_api_ex, \"~> 1.2\"},\n\n    # optional, but recommended adapter\n    {:hackney, \"~> 1.20\"}\n  ]\nend\n```\n\n> The default adapter is Erlang's built-in `httpc`, but it is not recommended to\n  use it in a production environment as it does not validate SSL certificates\n  among other issues.\n\nAnd ensure that `mixpanel_api_ex` is started before your application:\n\n```elixir\ndef application do\n  [applications: [:mixpanel_api_ex, :my_app]]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage Example - Mixpanel","doc":"Define an interface module with `use Mixpanel`.\n\n```elixir\n# lib/my_app/mixpanel.ex\n\ndefmodule MyApp.Mixpanel do\n  use Mixpanel\nend\n```\n\nConfigure the interface module in `config/config.exs`.\n\n```elixir\n# config/config.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel,\n  project_token: System.get_env(\"MIXPANEL_PROJECT_TOKEN\")\n```\n\nAnd then to track an event:\n\n```elixir\nMyApp.Mixpanel.track(\"Signed up\", %{\"Referred By\" => \"friend\"}, distinct_id: \"13793\")\n# => :ok\n```","ref":"readme.html#usage-example"},{"type":"extras","title":"TOC - Mixpanel","doc":"- [Configuration](#configuration)\n- [EU Data Residency](#eu-data-residency)\n- [Supported HTTP clients](#supported-http-clients)\n- [Running multiple instances](#running-multiple-instances)\n- [Running tests](#running-tests)\n- [Runtime/Dynamic configuration](#runtime-dynamic-configuration)\n- [Telemetry](#telemetry)\n- [Usage](#usage)\n- [Contributing](#contributing)\n- [License](#license)","ref":"readme.html#toc"},{"type":"extras","title":"Configuration - Mixpanel","doc":"#","ref":"readme.html#configuration"},{"type":"extras","title":"EU Data Residency - Mixpanel","doc":"By default `mixpanel_api_ex` sends data to Mixpanels's US Servers. However,\nthis can be changes via `:base_url` parameter:\n\n```elixir\n# config/config.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel,\n  base_url: \"https://api-eu.mixpanel.com\",\n  project_token: System.get_env(\"MIXPANEL_PROJECT_TOKEN\")\n```\n\n`:base_url` is not limited specifically to this URL. So if you need you can\nprovide an proxy address to route Mixpanel events via.\n\n#","ref":"readme.html#eu-data-residency"},{"type":"extras","title":"Supported HTTP clients - Mixpanel","doc":"At the moment `httpc` and `hackney` libraries are supported. `:http_adapter`\nparam can be used to select which HTTP adapter you want to use.\n\n```elixir\n# config/config.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel,\n  http_adapter: Mixpanel.HTTP.Hackney,\n  project_token: System.get_env(\"MIXPANEL_PROJECT_TOKEN\")\n```\n\n> The default adapter is Erlang's built-in `httpc`, but it is not recommended to\n  use it in a production environment as it does not validate SSL certificates\n  among other issues.\n\n#","ref":"readme.html#supported-http-clients"},{"type":"extras","title":"Running multiple instances - Mixpanel","doc":"You can configure multiple instances to be used by different applications within\nyour VM. For instance the following example demonstrates having separate client\nwhich is used specifically to sending data to Mixpanel's EU servers.\n\n```elixir\n# config/config.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel,\n  project_token: System.get_env(\"MIXPANEL_PROJECT_TOKEN\")\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel.EU,\n  base_url: \"https://api-eu.mixpanel.com\",\n  project_token: System.get_env(\"MIXPANEL_EU_PROJECT_TOKEN\")\n```\n\n```elixir\n# lib/my_app/mixpanel.ex\n\ndefmodule MyApp.Mixpanel do\n  use Mixpanel\nend\n```\n\n```elixir\n# lib/my_app/mixpanel_eu.ex\n\ndefmodule MyApp.MixpanelEU do\n  use Mixpanel\nend\n```\n\n#","ref":"readme.html#running-multiple-instances"},{"type":"extras","title":"Running tests - Mixpanel","doc":"Other than not running `mixpanel_api_ex` application in test environment you\nhave got two other options. Which one you need to use depends on if you want the\nclient process running or not.\n\nIf you prefer the client process to be up and running during the test suite\nrunning you may provide `Mixpanel.HTTP.NoOp` adapter to `:http_adapter` param.\nAs the adapter's name suggests it won't do any actual work sending data to\nMixpanel, but everything else will be running (including emitting Telemetry's\nevent).\n\n```elixir\n# config/test.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel,\n  project_token: \"\",\n  http_adapter: Mixpanel.HTTP.NoOp\n```\n\nThe second options would be simply assign `nil` as configuration value. This way\nthat client won't be started by the application supervisor.\n\n```elixir\n# config/test.exs\n\nconfig :mixpanel_api_ex, MyApp.Mixpanel, nil\n```\n\n#","ref":"readme.html#running-tests"},{"type":"extras","title":"Runtime/Dynamic Configuration - Mixpanel","doc":"In cases when you don't know upfront how many client instances you need and what\nproject tokens to use (for instance this information is read from a database or\na external configuration file during application startup) you can use\n`Mixpanel.start_client/1` and `Mixpanel.terminate_client/1` to manually run and\nkill instances when needed.\n\nFor instance this would start `MyApp.Mixpanel.US` named client with `\"token\"` project token:\n\n```elixir\nMixpanel.start_client(Mixpanel.Config.client(MyApp.Mixpanel.US, [project_token: \"token\"])\n# => {:ok, #PID }\n```\n\n`Mixpanel.Config.client/2` makes sure that provided parameters are correct.\n\nAnd when you done with it, this function would stop the client immediately:\n\n```elixir\nMixpanel.terminate_client(MyApp.Mixpanel.US)\n# => :ok\n```\n\nTo make it possible to call this client process you might want to use some macro\nmagic, which would compile a new module in runtime:\n\n```elixir\nast =\n  quote do\n    use Mixpanel\n  end\n\nModule.create(MyApp.Mixpanel.US, ast, Macro.Env.location(__ENV__))\n# => {:module, _module, _bytecode, _exports}\n```\n\nIf creating a module is not a case, you still can call the client's process\ndirectly (it's a GenServer after all). For instance:\n\n```elixir\nClient.track(MyApp.Mixpanel.US, event, properties, opts)\n# => :ok\n```","ref":"readme.html#runtime-dynamic-configuration"},{"type":"extras","title":"Usage - Mixpanel","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Tracking events - Mixpanel","doc":"Use `Mixpanel.track/3` function to track events:\n\n```elixir\nMyApp.Mixpanel.track(\n  \"Signed up\",\n  %{\"Referred By\" => \"friend\"},\n  distinct_id: \"13793\"\n)\n# => :ok\n```\n\nThe time an event occurred and IP address of an user can be provided via opts:\n\n```elixir\nMyApp.Mixpanel.track(\n  \"Level Complete\",\n  %{\"Level Number\" => 9},\n  distinct_id: \"13793\",\n  time: ~U[2013-01-15 00:00:00Z],\n  ip: \"203.0.113.9\"\n)\n# => :ok\n```\n\n#","ref":"readme.html#tracking-events"},{"type":"extras","title":"Tracking profile updates - Mixpanel","doc":"Use `Mixpanel.engage/3,4` function to track profile updates:\n\n```elixir\nMyApp.Mixpanel.engage(\n  \"13793\",\n  \"$set\",\n  %{\"Address\" => \"1313 Mockingbird Lane\"}\n)\n# => :ok\n```\n\nThe time an event occurred and IP address of an user can be provided via opts:\n\n```elixir\nMyApp.Mixpanel.engage(\n  \"13793\",\n  \"$set\",\n  %{\"Birthday\" => \"1948-01-01\"},\n  time: ~U[2013-01-15 00:00:00Z],\n  ip: \"123.123.123.123\"\n)\n# => :ok\n```\n\n`Mixpanel.engage/2` works with batches:\n\n```elixir\nMyApp.Mixpanel.engage(\n  [\n    {\"13793\", \"$set\", %{\"Address\" => \"1313 Mockingbird Lane\"}},\n    {\"13793\", \"$set\", %{\"Birthday\" => \"1948-01-01\"}}\n  ],\n  ip: \"123.123.123.123\"\n)\n# => :ok\n```\n\n#","ref":"readme.html#tracking-profile-updates"},{"type":"extras","title":"Merging two profiles - Mixpanel","doc":"Use `Mixpanel.create_alias/2` create an alias for a district ID, effectively\nmerging two profiles:\n\n```elixir\nMyApp.Mixpanel.create_alias(\"13793\", \"13794\")\n# => :ok\n```","ref":"readme.html#merging-two-profiles"},{"type":"extras","title":"Telemetry - Mixpanel","doc":"`mixpanel_api_ex` uses Telemetry to provide instrumentation. See the\n`Mixpanel.Telemetry` module for details on specific events.","ref":"readme.html#telemetry"},{"type":"extras","title":"Contributing - Mixpanel","doc":"1. Fork it (https://github.com/asakura/mixpanel_api_ex/fork)\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Test your changes by running unit tests and property based tests\n   (`mix t && mix p`)\n4. Check that provided changes does not have type errors (`mix dialyzer`)\n5. Additionally you might run Gradient to have extra insight into type problems\n   (`mix gradient`)\n6. Make sure that code is formatted (`mix format`)\n7. Run Credo to make sure that there is no code readability/maintainability\n   issues (`mix credo --strict`)\n8. Commit your changes (`git commit -am 'Add some feature'`)\n9. Push to the branch (`git push origin my-new-feature`)\n10. Create new Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - Mixpanel","doc":"This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details\n\nCopyright (c) 2016-2023 [Mikalai Seva](https://github.com/asakura/)","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"1.2.4 - Changelog","doc":"* Support for Erlang/OTP 22, 23, 24, 25 has been added\n* Elixir 1.12, 1.13, 1.14 are now supported\n* Elixir 1.16.0-rc.0 is supported on OTP 24, 25, 26 as well\n* If a project token present in properties it won't be overwritten\n* Dynamic starting/stopping of client processes was implemented","ref":"changelog.html#1-2-4"},{"type":"extras","title":"1.2.3 - Changelog","doc":"* NoOp was added to the list of known adapters\n* mix_unused was listed as dev only dependency","ref":"changelog.html#1-2-3"},{"type":"extras","title":"1.2.2 - Changelog","doc":"* Add VERSION to list of the package's extra files","ref":"changelog.html#1-2-2"},{"type":"extras","title":"1.2.1 - Changelog","doc":"* Fixes name of the default HTTP adapter","ref":"changelog.html#1-2-1"},{"type":"extras","title":"1.2.0 - Changelog","doc":"#","ref":"changelog.html#1-2-0"},{"type":"extras","title":"Breaking changes - Changelog","doc":"* Now you can configure the library in a such a way that it can be used to\n  stream to multiple Mixpanel accounts simultaneously. Consult with README.md on\n  how to use new API.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Improvements - Changelog","doc":"* Introduces Telemetry support.","ref":"changelog.html#improvements"},{"type":"extras","title":"1.1.0 - Changelog","doc":"#","ref":"changelog.html#1-1-0"},{"type":"extras","title":"Improvements - Changelog","doc":"* Supports Elixir 1.15 and Erlang/OTP 26: all compilation errors and warnings\n  were fixed.\n* User facing API now supports NaiveDateTime, DateTime, as well as Erlang's\n  timestamps and Erlang's Calendar `t:datetime()`.\n* Batch variant of engage function (`Mixpanel.engage/2`) has been added.\n* `Mixpanel.create_alias/2` has been added.\n* Poison has been replaced with Jason.\n* `base_url` option has been added which enables selection EU Residency servers\n  (or enables use of proxies of your choice).\n* Supports plug-able adapters for http libraries via `:http_adapter`\n  configuration parameter: implements default one using `httpc` OTP library and\n  and another one using Hackney library (won't be available until it listed as\n  dependency in your project's mix file).\n* If a request to Mixpanel backend fails for any reason, then it will be retries\n  up to 3 times.\n* All dependencies have been upgraded to their latest versions.\n\n#","ref":"changelog.html#improvements"},{"type":"extras","title":"Breaking changes - Changelog","doc":"* Mentions of the Token has been replaced with Project Token to reflect the\n  official docs. Rename `token` to `project_token` in the `config.exs`.\n\n#","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Deprecation - Changelog","doc":"* HTTPoison has been removed\n* Mock library was made obsolete\n* InchEx integration was removed\n* Dogma has been dropped\n\n#","ref":"changelog.html#deprecation"},{"type":"extras","title":"General code quality improvements - Changelog","doc":"* Travis has been obsolete and was replaced by GitHub actions.\n* Now the library uses Dependabot.\n* All typespecs were refined and thus improved the documentation.\n* Dialyzer errors have been fixed.\n* Credo's warnings and errors have been resolved\n* A lot of code repetition has been eliminated.\n* Better validation of user provided options has been added to user facing API\n  functions.\n* Since the library employs behaviours to implement HTTP client adapters, the\n  test suit was moved to Mox mocking framework and thus was simplified.\n* To test HTTP adapters, Bandit running in HTTPS mode was used.\n* Due to changes listed above, the test suite coverage was greatly improved.","ref":"changelog.html#general-code-quality-improvements"},{"type":"extras","title":"0.8.4 - Changelog","doc":"* Update deps","ref":"changelog.html#0-8-4"},{"type":"extras","title":"0.8.0 - Changelog","doc":"Initial release","ref":"changelog.html#0-8-0"}],"content_type":"text/markdown"}